﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Text;
using MySql.Data.MySqlClient;
using MySql.Data;
using System.Data;
using System.Data.SqlClient;

namespace IPLookup
{
    public partial class lookup : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            if (IsPostBack)
            {
                Boolean fileOK = false;
                String path = Server.MapPath("~");
                if (FileUpload1.HasFile)
                {
                    String fileExtension =
                        System.IO.Path.GetExtension(FileUpload1.FileName).ToLower();
                    String[] allowedExtensions = { ".txt", ".csv" };
                    for (int i = 0; i < allowedExtensions.Length; i++)
                    {
                        if (fileExtension == allowedExtensions[i])
                        {
                            fileOK = true;
                        }
                    }
                }

                if (fileOK)
                {
                    try
                    {
                        FileUpload1.PostedFile.SaveAs(path
                            + FileUpload1.FileName);
                        Label1.Text = "File uploaded!";

                        DisplayFileContents(FileUpload1.PostedFile);
                    }
                    catch (Exception ex)
                    {
                        Label1.Text = "File could not be uploaded.";
                    }
                }
                else
                {
                    Label1.Text = "Cannot accept files of this type.";
                }
            }
        }


        void DisplayFileContents(HttpPostedFile file)
        {
            Stream theStream = FileUpload1.PostedFile.InputStream;
            StringBuilder display = new StringBuilder();
            using (StreamReader sr = new StreamReader(theStream))
            {
                string line;
                char[] delimiter1 = new char[] { ',' };

                while ((line = sr.ReadLine()) != null)
                {
                    string[] iplist = line.Split(delimiter1, StringSplitOptions.None);

                    foreach (string IP in iplist)
                    {
                        display.Append("IP Address : " + IP.ToString() + "\n");

                        string ip_addr = IP;

                        long ip_num = ip_to_number(ip_addr);
                        string query = "SELECT * FROM ip2location_db11 WHERE ip_to >= " + ip_num + " order by ip_to limit 1";
                        string[] data = Get_Data(query);

                        string country_code = data[0];
                        string country_name = data[1];
                        string city_name = data[2];
                        string region_name = data[3];
                        string latitude = data[4];
                        string longitude = data[5];
                        string zip_code = data[6];
                        string time_zone = data[7];

                        //Define the result file that you want to output
                        string filePath = Server.MapPath("~") + "result.csv";

                        using (StreamWriter Sw = File.AppendText(filePath))
                        {
                            string output = string.Format("\"" + IP + "\"" + "," + "\"" + country_code + "\"" + "," + "\"" + country_name + "\"" + "," + "\"" + city_name + "\"" + "," + "\"" + region_name + "\"" + "," + "\"" + latitude + "\"" + "," + "\"" + longitude + "\"" + "," + "\"" + zip_code + "\"" + "," + "\"" + time_zone + "\"");

                            Console.WriteLine(output);
                            Sw.WriteLine(output);

                        }
                        Label3.Text = "Result File Path : " + Path.GetFullPath(filePath) + "<br>";
                    }
                }
            }

            Label4.Text = "Please DELETE the result file if you want to upload a new file! <br>";

        }


        public static string[] Get_Data(string query)
        {
            //Database connection string, replace lower capital with MySQL settings
            string db_con_string = "SERVER=server;DATABASE=database;UID=userid;PASSWORD=password;";
            using (MySqlConnection con = new MySqlConnection(db_con_string))
            {
                using (MySqlCommand cmd = new MySqlCommand())
                {
                    cmd.CommandText = query;
                    using (MySqlDataAdapter sda = new MySqlDataAdapter())
                    {
                        cmd.Connection = con;
                        sda.SelectCommand = cmd;
                        using (DataSet ds = new DataSet())
                        {
                            DataTable dt = new DataTable();
                            sda.Fill(dt);
                            object country_code = dt.Rows[0]["country_code"];
                            object country_name = dt.Rows[0]["country_name"];
                            object region_name = dt.Rows[0]["region_name"];
                            object city_name = dt.Rows[0]["city_name"];
                            object latitude = dt.Rows[0]["latitude"];
                            object longitude = dt.Rows[0]["longitude"];
                            object zip_code = dt.Rows[0]["zip_code"];
                            object timezone = dt.Rows[0]["time_zone"];
                            string[] data = { Convert.ToString(country_code), Convert.ToString(country_name), Convert.ToString(region_name), Convert.ToString(city_name), Convert.ToString(latitude), Convert.ToString(longitude), Convert.ToString(zip_code), Convert.ToString(timezone) };
                            return data;
                        }
                    }
                }
            }
        }

        //Function to convert IP Address to IP Number
        public long ip_to_number(string ip_addr)
        {
            string[] ip_Sblock;
            int[] ip_block = new int[4];
            string[] separator = { "." };

            ip_Sblock = ip_addr.Split(separator, StringSplitOptions.None);
            for (int i = 0; i <= 3; i++)
            {
                ip_block[i] = Convert.ToInt32(ip_Sblock[i]);
            }

            return ip_block[0] * 16777216 + ip_block[1] * 65536 + ip_block[2] * 256 + ip_block[3];
        }





    }
}